Bug # 5350 (Closed): WeakRef で謎の NoMethodError

r33361以降sample/test.rb:systemがFになる

10/13/2011 01:48 PM - ngoto (Naohisa Goto)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: 1.9.x Backport:  

Description

r33361の変更により、ccでコンパイルすると、プログラム終了時にfinalizerが呼ばれなくなり、sample/test.rb:system にFが出ます。

(Solaris 10, sparc, Sun Studio 11 にて確認)

% make test

(中略)

sample/test.rb:eval .............................

sample/test.rb:system .FFFF.F.

sample/test.rb:const .....

(中略)

sample/test.rb:path .......................

sample/test.rb:gc ....make: *** [yes-test-sample] Error 1

Fが出ているテストの1つは以下です。

test_ok(./miniruby -e 'print "foobar"' == 'foobar')

r33361の変更で、以下の文が2か所に追加されています。

if (ATOMIC_SET(finalizing, 1)) return;

マクロ ATOMIC_SET() は、gccの場合(ただしWindows以外)、

define ATOMIC_SET(var, val)  __sync_lock_test_and_set(&(var), (val))

に展開され、http://gcc.gnu.org/onlinedocs/gcc/Atomic-Builtins.html によるとこの関数は

returns the previous contents of *ptr.

つまり、その変数に以前セットされていた値を返しますが、

gccおよびWIN32以外(Solarisのccなど)では、

 

define ATOMIC_SET(var, val) ((var) = (val))

に展開される、つまり、新しく代入した値を返すため、

if (ATOMIC_SET(finalizing, 1)) return;

は、ATOMIC_SET(finalizing, 1)が必ず1を返すため、常にreturnしてしまいます。

このため、多くのfinalizerが呼ばれないままプログラムが終了し、rb_io_fptr_finalizeなどで行われているバッファのフラッシュも行われないためFになったと推測します。

Associated revisions

Revision c180eabf - 10/13/2011 09:04 AM - nobu (Nobuyoshi Nakada)

gc.c (rb_gc_finalize_deferred, rb_objspace_call_finalizer):

should use ATOMIC_EXCHANGE() to check the previous value.

[ruby-dev:44596] [Bug #5439]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@33460 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 123645aa - 10/13/2011 09:19 AM - kosaki (Motohiro KOSAKI)

atomic.h(ATOMIC_SET): add cast to void to prevent misuse.

[ruby-dev:44596] [Bug #5439]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@33462 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 5558de40 - 10/13/2011 10:39 AM - ngoto (Naohisa Goto)

atomic.h (ATOMIC_*): use atomic_ops(3C) when SunStudio on Solaris.

[ruby-dev:44596] [Bug #5439]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@33463 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision c96c193e - 10/13/2011 08:58 PM - nobu (Nobuyoshi Nakada)

atomic.h (ATOMIC_INC, ATOMIC_DEC): return old values.

[ruby-dev:44596] [Bug #5439]

signal.c (ruby_atomic_exchange): no needs to define on the

platforms where atomic.h is available.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@33464 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 2e574a5315e611ae2f5375bffb3827c64e1a0f17 - 01/30/2014 10:11 AM - U.Nakamura 

merge revision(s) 33361,33460: [Backport #9463]

    * gc.c (slot_sweep, rb_gc_finalize_deferred)

      (rb_objspace_call_finalizer, rb_gc): run finalizers

      sequencially.  [ruby-dev:44562]

    * gc.c (rb_gc_finalize_deferred, rb_objspace_call_finalizer):

      should use ATOMIC_EXCHANGE() to check the previous value.

      [ruby-dev:44596] [Bug #5439]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@44762 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 2e574a53 - 01/30/2014 10:11 AM - U.Nakamura 

merge revision(s) 33361,33460: [Backport #9463]

    * gc.c (slot_sweep, rb_gc_finalize_deferred)

      (rb_objspace_call_finalizer, rb_gc): run finalizers

      sequencially.  [ruby-dev:44562]

    * gc.c (rb_gc_finalize_deferred, rb_objspace_call_finalizer):

      should use ATOMIC_EXCHANGE() to check the previous value.

      [ruby-dev:44596] [Bug #5439]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@44762 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 10/13/2011 03:12 PM - shyouhei (Shyouhei Urabe)

その他のコンパイラの場合はそれはそれで修正すべきと思いますが、sparc上のccにはatomic test and setみたいなインストラクション(があるのか存じ上げませんが)を生成する方法はないのでしょうか?

あるのならそちらを使うようにするのが筋という気がします。

#2 - 10/13/2011 03:13 PM - kosaki (Motohiro KOSAKI)

代入前の値を知りたいときは ATOMIC_EXCHANGE 使わないとダメ。

やらないといけないことが３つあって

１．ATOMIC_SETに void キャストいれて、戻り値使おうとしたらコンパイルエラーになるようにする

２．指摘されてる間違った ATOMIC_SEC を ATOMIC_EXCHANGEに変換

３．いまatomicに対応してるのはgccとVCだけなので、#if defined(__SUNPRO_CC) だったら

http://www.unix.com/man-page/OpenSolaris/9f/atomic_ops/

の命令つかって、atomicに動くように実装する

１と２はこちらでさっくり出来そうですが、３はこちらではコンパイルテストすら出来ないので

協力していただけると助かります

#3 - 10/13/2011 03:41 PM - ngoto (Naohisa Goto)

３．いまatomicに対応してるのはgccとVCだけなので、#if defined(__SUNPRO_CC) だったら http://www.unix.com/man-page/OpenSolaris/9f/atomic_ops/ 

の命令つかって、atomicに動くように実装する
 Solaris10ではヘッダの場所が #include <atomic.h> となっているのがOpenSolarisと違いますが、関数の仕様は同じのようです。（もっとも、Solaris10 の atomic.h を覗いたら、単に #include

<sys/atomic.h> しているだけでしたが）

https://sites.google.com/a/diviware.com/unix/unix-page/solaris-page/solaris-man-pages/3c/atomic_ops

NetBSDなど他のOSにも同等/類似の関数があるようですので、configureで判別するほうが幸せかもしれません。

http://www.daemon-systems.org/man/atomic_ops.3.html

#4 - 10/13/2011 06:04 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r33460.

Naohisa, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.
